﻿//Dom Tree Viewer v0.8 UserJS by Emrah BASKAYA
//Free to build upon and redistribute, as long as you attribute the original author.
//Copy this to your UserJS directory and shift+ctrl+alt+LeftClick to activate the script on any page.
//The UL list style is provided by Kildor @ my.opera forums, and slightly modified.

var domTreeVars = new Array()
domTreeVars.winR, domTreeVars.docW
domTreeVars.showNodeVals = true;
domTreeVars.blinkColor =  "red";
domTreeVars.colStyle = 'color: #114;';
domTreeVars.expStyle  = 'color: #411;';
domTreeVars.hoverStyle = 'color: #13E;';
domTreeVars.colImage = 'url("data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAIAAAACUFjqAAAABGdBTUEAAK%2FINwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAAsSURBVHjaYpSVlWXADViA%2BNGjRxCOnJwcGpeJAS8gIM2I324CugfSaQABBgCQjQ0bDC2y7AAAAABJRU5ErkJggg%3D%3D")';
domTreeVars.expImage = 'url("data:image/png;base64,iVBORw0KGgoAAAANSUhEUgAAAAoAAAAKCAIAAAACUFjqAAAABGdBTUEAAK%2FINwWK6QAAABl0RVh0U29mdHdhcmUAQWRvYmUgSW1hZ2VSZWFkeXHJZTwAAAAqSURBVHjaYpSVlWXADViA%2BNGjR1jl5OTkmBjwAgLSLBBDKNA9UE4DCDAATgcHJ4RtH9cAAAAASUVORK5CYII%3D")';

/*
domTreeVars.mainStyle = 'body {background-color: #99A;}'
+'h1 {font-size: 120%;width: 98%;margin: 0.2em auto; text-align:center;}'
+'h1 span {font-size:125%;}'
+'.idspan, .classspan {font-style: italic; margin-right: 1em;}';
*/

domTreeVars.mainStyle = 'body {background-color: #99A;}'
+'h1 {font-size: 130%;width: 98%;margin: 0.2em auto; text-align:center;}'
+'h1 span {font-size:135%;}'
+'#domtree {border:2px solid #fff;border-width:2px 0 2px 0px;}'
+'ul {margin-left: 10px;}'
+'li {padding:0;margin:0;list-style-type:none;}'
+'li.lastchild {border-left:1px outset #99a;}'
+'li {border-left:1px solid #fff;padding-bottom:1px;padding-left:4px;}'
+'li:before {content:"";width:10px;margin-left:-5px;height:2px;line-height:1px;font-size:1px;display:block;padding-top:7px;float:left;border:2px solid #fff;border-width:0 0 1px 1px;}'
+'#domtree ul {border:2px solid #868493; border-width:0 0 1px 0px;} '
+'.collapsedbranch>span, .expandedbranch>span {padding-left: 11px;} '
+'.collapsedbranch>span:hover, .expandedbranch>span:hover {'+domTreeVars.hoverStyle+'} '
+'.collapsedbranch>span {background: transparent '+domTreeVars.colImage+' no-repeat 0% 50%} '
+'.expandedbranch>span {background: transparent '+domTreeVars.expImage+' no-repeat 0% 50%} '
+'li>span>span {padding-left: 0.2em;} '
+'.nochildbranch {list-style-image: none; list-style-type: disc;} '
+'#settings {text-align: center;font-size: 70%; float:right; margin-top:1em; width:15em; background-color:white;}'
+'.idspan, .classspan {font-size: 90%; font-style: italic; color: white; }'
+'.nodevaluespan {font-size: 90%;};'
;


/* init vars */


addTrigger(window,'load', listDom);

function listDom() {
addTrigger(window,'mouseup', mKeyCheck);
}

function mKeyCheck(event) {
if (event.shiftKey && event.altKey && event.ctrlKey) {
domTreeVars.winR=window.open('','myconsole','width=600,height=400,menubar=0,toolbar=1,status=0,scrollbars=1,resizable=1')
domTreeVars.winR.document.writeln('<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">'
+'<html xmlns="http://www.w3.org/1999/xhtml">'
+'<head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" />'
+'<title>DOM Tree Viewer v0.7 by Hesido. Viewing "'+document.title+'"</title>'
+'<style>'+domTreeVars.mainStyle+' '
+'</style>'
+'<body onLoad="self.focus()">'
+'<h1>Dom Tree Of <span>'+document.title+'</span></h1>'
+'<div id="settings">Turn Off Node Value Display</div>'
+'<p>Shift-Click to recursive collapse/expand; Ctrl-Click to highlight the element.</p>'
+'</body></html>'
);
domTreeVars.winR.document.close()
domTreeVars.docW = domTreeVars.winR.document;
domTreeVars.domLister = domTreeVars.docW.createElement('div');
domTreeVars.docW.body.appendChild(domTreeVars.domLister);
doTheList();
domTreeVars.clicker = domTreeVars.docW.getElementById('settings');
domTreeVars.clicker.onclick = function() {
	if (domTreeVars.showNodeVals) {
		domTreeVars.showNodeVals = false;
		domTreeVars.clicker.innerHTML = "Turn On Node Value Display";}
	else {domTreeVars.showNodeVals = true;
		domTreeVars.clicker.innerHTML = "Turn Off Node Value Display";
		}
	doTheList();}
}

}

function doTheList() {
if (domTreeVars.docW.getElementById('domtree') != null) domTreeVars.docW.getElementById('domtree').parentNode.removeChild(domTreeVars.docW.getElementById('domtree'));
var domUL = domTreeList(domTreeVars.domLister,document);
domUL.id = 'domtree';
navigationSetD(domUL,'collapsedbranch','expandedbranch','nochildbranch');
}



// Dom Tree Lister v0.3 Opera UserJS by Emrah BASKAYA www.hesido.com
// You are free to modify and redistribute, as long as the author is attributed;
function domTreeList(appeN,tEL) {
var tS, aUL, lN, hL, nN, nnSp, eiDv;
hL = tEL.childNodes; aUL = domTreeVars.docW.createElement('ul');


for (var i=0; i<hL.length; i++) {
	nN = hL[i].nodeName
	lN = crElem('li',aUL,'','','');
	nnSp = crElem('span',lN,'','nodenamespan',nN)
	eiDv = crElem('div',null,'','extrainfo','');
	if (hL[i].id && hL[i].id != '') crElem('span',eiDv,'','idspan','id: '+hL[i].id+' ');
	if (hL[i].className && hL[i].className != '') crElem('span',eiDv,'','classspan','class: '+hL[i].className);
	if (domTreeVars.showNodeVals && hL[i].nodeValue && hL[i].nodeValue != '') crElem('span',eiDv,'','nodevaluespan','nodevalue: '+ hL[i].nodeValue.substr(0,50));
	if (eiDv.childNodes.length > 0) lN.appendChild(eiDv);
	nnSp.tiedNode = hL[i];
	nnSp.tied = true;
	if (hL[i].childNodes.length > 0) domTreeList(lN,hL[i]);
}
if (aUL.hasChildNodes) {appeN.appendChild(aUL);return(aUL);}
return false;
}

function crElem(elt,appt,dId,dclass,inHTM) {
	var lN = domTreeVars.docW.createElement(elt); lN.id = dId; lN.className = dclass; lN.innerHTML = inHTM;
	if (appt != null) appt.appendChild(lN);
	return lN;
}

/*
Navigation List Display control (no switch collapse version)
v0.5- JavaScript By www.hesido.com - Freely Distributable On Condition of Attribution;
*/

function navigationSetD(targetList,colClass,expClass,nchClass) {
	var ulLis = targetList.getElementsByTagName("ul");
	var spLisd = targetList.getElementsByTagName("span");
	for (var i=0; i<ulLis.length; i++) {ulLis[i].style.display = "none";}
	for (var i=0; i < spLisd.length; i++) {
		if (spLisd[i].tied == true) {
			spLisd[i].onclick = handleMdown; spLisd[i].expcol = null;
			spLisd[i].spId = i; spLisd[i].parentNode.className = nchClass;
		}
		var newBranch = spLisd[i].parentNode.getElementsByTagName("ul");
		if (newBranch.length > 0) {
			spLisd[i].expcol = newBranch[0];
			spLisd[i].expcol.collap = true; 
			spLisd[i].expcol.parentL = spLisd[i].parentNode;
			spLisd[i].expcol.parentL.className = colClass;
			spLisd[i].pcolClass = colClass;
			spLisd[i].pexpClass = expClass;
		}
	}
}

function handleMdown(event) {
if (this.tiedNode.style && event.ctrlKey) eBlinker(this);
if (this.expcol != null && !event.ctrlKey) expandCollapseD(this,event.shiftKey);
}

function expandCollapseD(sP,shiftP) {
	if (sP.expcol.collap == true) {
		sP.expcol.style.display = "block"; sP.expcol.parentL.className = sP.pexpClass; sP.expcol.collap = false;
		if (shiftP) {
			var subULs = sP.expcol.getElementsByTagName('ul');
			for (var i=0; i<subULs.length; i++) {
				subULs[i].style.display = "block"; subULs[i].collap = false; subULs[i].parentL.className = sP.pexpClass;
			}
		}
	}
	else {
		sP.expcol.style.display = "none"; sP.expcol.parentL.className = sP.pcolClass; sP.expcol.collap = true;
		if (shiftP) {
			var subULs = sP.expcol.getElementsByTagName('ul');
			for (var i=0; i<subULs.length; i++) {
				subULs[i].style.display = "none"; subULs[i].collap = true;  subULs[i].parentL.className = sP.pcolClass;
			}
		}
	}
}


function eBlinker(elm) {
var telm = elm.tiedNode;
if (telm.atimeout == true) return;
var cL = 0, cT = 0, obj = telm;
telm.oldId = telm.id;
telm.oldSt = getStyleD(telm,'background-color');
telm.style.backgroundColor = domTreeVars.blinkColor;
while (obj.offsetParent){cL += obj.offsetLeft;cT += obj.offsetTop;obj = obj.offsetParent;}
window.scrollTo(cL-Math.round(self.innerWidth/2),cT-Math.round(self.innerHeight/2));
if (telm.id == '') telm.id = 'dtviva_x'+elm.spId;
window.setTimeout('unBlink("'+telm.id+'","'+telm.oldId+'","'+telm.oldSt+'","'+domTreeVars.blinkColor+'",0,5)',150)
}

function unBlink(elId,elBId,elOlc,elTac,count,mcount) {
var unB = document.getElementById(elId);
unB.atimeout = true;
var cnum = count/2;
if (cnum != Math.round(cnum)) unB.style.backgroundColor = elTac;
else unB.style.backgroundColor = elOlc;
count++
if (count != mcount) window.setTimeout('unBlink("'+elId+'","'+elBId+'","'+elOlc+'","'+elTac+'",'+count+','+mcount+')',150)
else {unB.atimeout = false; unB.id = elBId;}
}

function getStyleD(elem,style) {
if (elem.getComputedStyle) return window.getComputedStyle(elem,null).getPropertyValue(style)
return '';
}


function addTrigger(elm,eventname,func) {
// Event Listener With Check - Emrah BASKAYA
if (!addCheckTrigger(elm,eventname,func)) elm.attachEvent('on'+eventname, func);
}

function addCheckTrigger(elm,eventname,func) {
if (elm.addEventListener) {elm.addEventListener(eventname, func, false); return true;}
else return false;
}


